<?xml version="1.0" encoding="ASCII"?>

<!-- oks-schema version 2.0 -->

<!DOCTYPE oks-schema [
  <!ELEMENT oks-schema (info, (include)?, (class)+)>
  <!ELEMENT info EMPTY>
  <!ATTLIST info
      name CDATA #REQUIRED
      type CDATA #REQUIRED
      num-of-includes CDATA #REQUIRED
      num-of-items CDATA #REQUIRED
      oks-format CDATA #FIXED "schema"
      oks-version CDATA #REQUIRED
      created-by CDATA #REQUIRED
      created-on CDATA #REQUIRED
      creation-time CDATA #REQUIRED
      last-modified-by CDATA #REQUIRED
      last-modified-on CDATA #REQUIRED
      last-modification-time CDATA #REQUIRED
  >
  <!ELEMENT include (file)+>
  <!ELEMENT file EMPTY>
  <!ATTLIST file
      path CDATA #REQUIRED
  >
  <!ELEMENT class (superclass | attribute | relationship | method)*>
  <!ATTLIST class
      name CDATA #REQUIRED
      description CDATA ""
      is-abstract (yes|no) "no"
  >
  <!ELEMENT superclass EMPTY>
  <!ATTLIST superclass name CDATA #REQUIRED>
  <!ELEMENT attribute EMPTY>
  <!ATTLIST attribute
      name CDATA #REQUIRED
      description CDATA ""
      type (bool|s8|u8|s16|u16|s32|u32|float|double|date|time|string|uid|enum) #REQUIRED
      range CDATA ""
      format (dec|hex|oct) "dec"
      is-multi-value (yes|no) "no"
      multi-value-implementation (list|vector) "list"
      init-value CDATA ""
      is-not-null (yes|no) "no"
  >
  <!ELEMENT relationship EMPTY>
  <!ATTLIST relationship
      name CDATA #REQUIRED
      description CDATA ""
      class-type CDATA #REQUIRED
      low-cc (zero|one) #REQUIRED
      high-cc (one|many) #REQUIRED
      is-composite (yes|no) #REQUIRED
      is-exclusive (yes|no) #REQUIRED
      is-dependent (yes|no) #REQUIRED
      multi-value-implementation (list|vector) "list"
  >
  <!ELEMENT method (method-implementation*)>
  <!ATTLIST method
      name CDATA #REQUIRED
      description CDATA ""
  >
  <!ELEMENT method-implementation EMPTY>
  <!ATTLIST method-implementation
      language CDATA #REQUIRED
      prototype CDATA #REQUIRED
      body CDATA ""
  >
]>

<oks-schema>

<info name="" type="" num-of-includes="1" num-of-items="1" oks-format="schema" oks-version="oks-03-05-06 built &quot;Aug 30 2006&quot;" created-by="gruwe" created-on="lxplus051" creation-time="26/3/04 09:34:04" last-modified-by="svale" last-modified-on="pcslim2.bo.infn.it" last-modification-time="23/11/06 14:22:11"/>

<include>
 <file path="daq/schema/df.schema.xml"/>
</include>

<class name="PatternBankConf" description="Pattern bank file configuration">
  <attribute name="NumPattPerChip" description="Number of pattern to be loaded per chip" type="u32" format="dec" init-value="0"/>
  <attribute name="FilePath" description="Path of Pattern Bank" type="string"/> 
  <attribute name="BankType" description="Pattern Bank type: 0 for root format, 1 for ASCII format" type="u32" init-value="0"/> 
  <attribute name="SSOffset" description="offset for superstrip values to avoid SSID 0 which would always match" type="bool" init-value="0"/>
  <attribute name="InChipOff" description="The first internal value used by the patterns" type="u32" init-value="1"/>
  <attribute name="AMBChecksum" description="Checksum for the AMB" type="u32" init-value="0x0"/>
  <attribute name="Proc1Checksum" description="Checksum on AUX Processor FPGA 1" type="u32" init-value="0x0"/>
  <attribute name="Proc2Checksum" description="Checksum on AUX Processor FPGA 2" type="u32" init-value="0x0"/>
  <attribute name="Proc3Checksum" description="Checksum on AUX Processor FPGA 3" type="u32" init-value="0x0"/>
  <attribute name="Proc4Checksum" description="Checksum on AUX Processor FPGA 4" type="u32" init-value="0x0"/>
</class>

<class name="FTKEMonDataOut" description="DataOut plugin for sending data to the emon system">
 <superclass name="EMonDataOut"/>
</class>

<class name="ReadoutConfiguration_FTK">
 <superclass name="ReadoutConfiguration"/>
 <attribute name="GlobalThreadLimit" description="Maximum number of concurrent threads used by ReadoutModule_FTK, can be overriden by the transition-specific limits." type="u32" init-value="8" is-not-null="yes"/>
 <attribute name="ConfigureThreadLimit" description="Maximum number of concurrent threads used by ReadoutModule_FTK for the configure transition." type="s32" init-value="-1" is-not-null="yes"/>
 <attribute name="ConnectThreadLimit" description="Maximum number of concurrent threads used by ReadoutModule_FTK for the connect transition." type="s32" init-value="-1" is-not-null="yes"/>
 <attribute name="PrepareForRunThreadLimit" description="Maximum number of concurrent threads used by ReadoutModule_FTK for the prepareForRun transition." type="s32" init-value="-1" is-not-null="yes"/>
 <attribute name="StopThreadLimit" description="Maximum number of concurrent threads used by ReadoutModule_FTK for the stop transition." type="s32" init-value="-1" is-not-null="yes"/>
 <attribute name="DisconnectThreadLimit" description="Maximum number of concurrent threads used by ReadoutModule_FTK for the disconnect transition." type="s32" init-value="-1" is-not-null="yes"/>
 <attribute name="UnconfigureThreadLimit" description="Maximum number of concurrent threads used by ReadoutModule_FTK for the unconfigure transition." type="s32" init-value="-1" is-not-null="yes"/>
</class>

<class name="ReadoutModule_FTK">
 <superclass name="ReadoutModule"/>
 <attribute name="UseDefaultConfig" description="Whether to use the default ReadoutModule_FTK configuration flag defined in ReadoutModule_FTK.h" type="bool" init-value="1" is-not-null="yes"/>
 <attribute name="ParallelConfigure" description="Whether to parallelize the Configure transition." type="bool" init-value="0" is-not-null="yes"/>
 <attribute name="ParallelConnect" description="Whether to parallelize the Connect transition." type="bool" init-value="0" is-not-null="yes"/>
 <attribute name="ParallelPrepareForRun" description="Whether to parallelize the PrepareForRun transition." type="bool" init-value="0" is-not-null="yes"/>
 <attribute name="ParallelStopROIB" description="Whether to parallelize the StopROIB transition." type="bool" init-value="0" is-not-null="yes"/>
 <attribute name="ParallelStopDC" description="Whether to parallelize the StopDC transition." type="bool" init-value="0" is-not-null="yes"/>
 <attribute name="ParallelStopHLT" description="Whether to parallelize the StopHLT transition." type="bool" init-value="0" is-not-null="yes"/>
 <attribute name="ParallelStopRecording" description="Whether to parallelize the StopRecording transition." type="bool" init-value="0" is-not-null="yes"/>
 <attribute name="ParallelStopGathering" description="Whether to parallelize the StopGathering transition." type="bool" init-value="0" is-not-null="yes"/>
 <attribute name="ParallelStopArchiving" description="Whether to parallelize the StopArchiving transition." type="bool" init-value="0" is-not-null="yes"/>
 <attribute name="ParallelDisconnect" description="Whether to parallelize the Disconnect transition." type="bool" init-value="0" is-not-null="yes"/>
 <attribute name="ParallelUnconfigure" description="Whether to parallelize the Unconfigure transition." type="bool" init-value="0" is-not-null="yes"/>
 <attribute name="ParallelMonitoring" description="Whether to parallelize the monitoring functions." type="bool" init-value="0" is-not-null="yes"/>
 <attribute name="SeparatePublishThreads" description="Whether to use separate threads for publish and publishFullStats." type="bool" init-value="0" is-not-null="yes"/>
 <attribute name="ProtectStart" description="Whether to prevent publish(FullStats) from executing concurrently with prepareForRun" type="bool" init-value="0" is-not-null="yes"/>
 <attribute name="ProtectStop" description="Whether to prevent publish(FullStats) from executing concurrently with stop" type="bool" init-value="0" is-not-null="yes"/>
 <attribute name="SerializeRCDMonitoring" description="All RM's with this set true will lock a process-level mutex when executing publish(FullStats), thus preventing concurrency in monitoring." type="bool" init-value="0" is-not-null="yes"/>
</class>

</oks-schema>
